ProtoObject subclass: #Proxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxy-Objects'!

!Proxy methodsFor: 'inicialization' stamp: 'LDM 10/7/2004 00:00'!
prvInitialize: initializer
	" Private - Initialize the receiver with initializer. "

	^self subclassResponsibility! !


!Proxy methodsFor: 'message understanding' stamp: 'LDM 10/7/2004 00:02'!
doesNotUnderstand: aMessage
	" Evaluate aMessage in the receiver's context. "

	^self subclassResponsibility! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Proxy class
	instanceVariableNames: ''!

!Proxy class methodsFor: 'as yet unclassified' stamp: 'LDM 10/7/2004 00:08'!
for: initializer
	" Returns an instance of the receiver. "

	^self new prvInitialize: initializer! !


Proxy subclass: #Future
	instanceVariableNames: 'semaphore result '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxy-Objects'!
!Future commentStamp: 'LDM 10/7/2004 00:11' prior: 0!
"Test 1"
| test |
test := [ Transcript cr;show: 'computing the future value...'. 12 factorial ] future.
Transcript cr;show: 'prologue'.
test inspect.
Transcript cr;show: 'done.'.

"Test 2"
| object |
object := [(Delay forSeconds: 5) wait. Transcript cr; show: 'Future done...'. 6] future.
Transcript cr; show: object printString.
Transcript cr; show: object printString.!


!Future methodsFor: 'message understanding' stamp: 'LDM 10/7/2004 00:07'!
doesNotUnderstand: aMessage
	" Evaluate aMessage in the receiver's context. "

	self == result ifTrue: [ semaphore wait. ].
	^result
		perform: aMessage selector
		withArguments: aMessage arguments! !


!Future methodsFor: 'inicialization' stamp: 'LDM 10/7/2004 00:06'!
prvInitialize: initializer
	" Private - Initialize the receiver with initializer. "

	result := self.
	semaphore := Semaphore new.
	[	result := initializer value.
		semaphore signal.
	] fork.! !


Proxy subclass: #Promise
	instanceVariableNames: 'result action '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxy-Objects'!
!Promise commentStamp: 'LDM 10/7/2004 00:12' prior: 0!
"Test 1"
| test |
test := [ Transcript cr;show: 'computing the promise value...'. 12 factorial ] promise.
Transcript cr;show: 'prologue'.
test inspect.
Transcript cr;show: 'done.'.


"Test 2"
|object|
object := [Transcript cr; show: 'Promise done...'. 6] promise.
(Delay forSeconds: 5) wait. 
Transcript cr; show: object printString.
Transcript cr; show: object printString.!


!Promise methodsFor: 'message understanding' stamp: 'LDM 10/7/2004 00:04'!
doesNotUnderstand: aMessage
	" Evaluate aMessage in the receiver's context. "

	self == result ifTrue: [
		result := action value.
	].
	^result
		perform: aMessage selector
		withArguments: aMessage arguments! !


!Promise methodsFor: 'inicialization' stamp: 'LDM 10/7/2004 00:05'!
prvInitialize: initializer
	" Private - Initialize the receiver with initializer. "

	action := initializer.
	result := self.! !
